=== debian/changelog ===
openoffice.org (1:3.2.0-7ubuntu4.1) lucid-security; urgency=low

  * debian/patches/cws-ooo321gsl04.diff:
    ooo-build-3-2-0-10/patches/dev300/apply:
    ooo-build-3-2-0-10/patches/dev300/cws-ooo321gsl04.diff: fix
    "auto-execution of python code when manually browsing macro names"
    - CVE-2010-0395

 -- Chris Cheney <ccheney@ubuntu.com>  Tue, 01 Jun 2010 08:20:00 -0500

openoffice.org (1:3.2.0-7ubuntu4) lucid; urgency=low

  [ Michael Vogt ]
  * change the way components like -evolution or -filter-binfilter are
    registered so that we do not need to pre-depends on
    openoffice.org-core anymore (LP: #516727, #566584)
  
  [ Matthias Klose ]
  * debian/rules:
    - no not use lzma on armel (LP: #568940)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 21 Apr 2010 09:09:37 +0200

openoffice.org (1:3.2.0-7ubuntu3) lucid; urgency=low

  * debian/rules: Don't forget to set ENABLE_SDBC_POSTGRESQL=y in the default
    case :/

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 18 Apr 2010 21:16:57 +0000

openoffice.org (1:3.2.0-7ubuntu2) lucid; urgency=low

  * debian/rules: don't try to build minimizer, pdfimport, presenter-console,
    or sdbc-postgresql when arch-dep extensions are disabled.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 18 Apr 2010 11:05:02 +0000

openoffice.org (1:3.2.0-7ubuntu1) lucid; urgency=low

  * Resynchronise with Debian (r1940). Remaining changes:
    - Add Launchpad integration support.
    - Add Launchpad translations support.
    - Add package openoffice.org-style-human.
    - Add some Ubuntu-specific bitmaps. Adjust broffice diversions for these.
    - Add support for compressing debs with lzma.
    - Add support for shared /usr/share/doc directories.
    - Add support to build l10n as a separate source.
    - Add Xb-Npp-xxx tags according to "firefox distro add-on suport" spec.
    - openoffice.org-help switch to internal copy of lucene.
    - Disable check_for_running_ooo as it appears to not be needed anymore.
    - Disable gnome-vfs support since it is buggy.
    - Disable URE debconf warning.
    - Switch desktop files from %U to %F for gvfs fuse.
  * Disable lpi bug reporting for lucid per blueprint.
  * Update COMMON_DOCDIR to further reduce duplication.
  * Update Human icon theme.
  * Update Oracle logo on OOo splash screen.
  * Update Latvian translation. Closes LP: #555716
  * Correct Latvian locale settings. Closes LP: #555276
  * Work around apt upgrade bug for openoffice.org-evolution.
    Closes: LP: #556348
  * Force OOo to build for ARM instead of thumb2 to work around a segfault.
    Closes LP: #555977

 -- Chris Cheney <ccheney@ubuntu.com>  Wed, 14 Apr 2010 12:00:00 -0500

openoffice.org (1:3.2.0-7) unstable; urgency=low

  * ooo-build:
    - update (3.2.0.10)

  * debian/patches/branch-update-bc571534c9b7435429003010d733e9c3a34df32d.diff:
    remove
  * debian/patches/es-fix-buleano.diff: fix spanish "boolean value" translation
    (closes: #576842)
  * debian/patches/nsplugin-path-handle-relative-symlinks.diff: add patch
    from upstream to handle relative symlinks (closes: #570452)
  * debian/patches/nsplugin-long.diff: add patch from issue 110747 to fix
    the plugin on 64bit archs

  * debian/rules, debian/shlibs.*: fix shlib-dependencies to not depend
    on the kdelibs5 transitional package anymore when built with KDE 4.4 
  * debian/rules:
    - remove trailing ), breaking the libmysqlcppconn-dev build-dep on sparc
    - disable binfilter building on mips(el) like we do on arm(el) to save
      build time
    - remove libnpsoplugin.so symlinks in dirs except /usr/lib/mozilla
      (which is the canonical location)
  * debian/scripts/vars.s390x: add, we have S390X conditionals in rules
    after all
  * debian/rules, debian/control*in: GAH, I missed that armel has broken
    arch-dep extensions, Reintroduce %OOO_ARCH_DEP_EXTENSIONS_ARCHS%
  * debian/control.in: add also Pre-Depends on -common for -evolution to
    work around APT bug (thanks Ubuntu..).
    Do the same for -filter-binfilter to make it have orrect Pre-Depends:
    again
  * debian/rules, debian/control.lenny_squeeze_transitional.in: add
    transitional packages for xx-IN -> xx move as Conflicts/Provides/Replaces
    alone doesn't seem to work

 -- Rene Engelhard <rene@debian.org>  Wed, 14 Apr 2010 19:31:44 +0200

openoffice.org (1:3.2.0-6) unstable; urgency=low

  * debian/patches/cws-linuxaxp01.diff: update
  * debian/patches/branch-update-f7b99eb375dea6024a48ca1b41f8bc76c220a38e.diff:
    move ...
  * debian/patches/branch-update-bc571534c9b7435429003010d733e9c3a34df32d.diff:
    ... here and update to current git
    - removes (bogus) last hunk in last interator usage fix (closes: #576665)

  * debian/rules:
    - remove obsolete filter-out for libmysqlcppconn-dev builddep so it
      actually gets added for i386... 
    - add -F0 to QUILT_OPTIONS
    - re-enable arch-dep extensions for m68k
    - fix rule for replacing the old -in packages to not add it in
      uppercase (closes: #576721)
    - fix python-uno install for 2.6. $(shell is bad here
  * debian/rules, debian/control*in: remove %OOO_ARCH_DEP_EXTENSIONS_ARCHS%
    again

 -- Rene Engelhard <rene@debian.org>  Wed, 07 Apr 2010 00:27:20 +0200

openoffice.org (1:3.2.0-5) unstable; urgency=low

  * ooo-build:
    - update (3.2.0.9) 
      - branch_directly_to_cpp_vtable_call_on_arm.diff: adds
        ARM bridges fix from issue 105359

  * debian/patches/update-mysqlc.diff: "update" MySQL Connector to the
    version which (unnannounced) went in to 3.2.1
  * debian/patches/cws-linuxaxp01.diff: add alpha port from issue 110145
  * debian/patches/fix-system-redland.diff: remove redland patches
    allowing to use system-redland and reset security preferences (from issues
    108911 and 110523)
  * debian/patches/branch-update-f7b99eb375dea6024a48ca1b41f8bc76c220a38e.diff:
    update ooo-build-3-2 branch
    - Fix invalid iterator usage in X11SalGraphics::drawPolyPolygon 

