=== debian/rules ===
#!/usr/bin/make -f
################################################################################
# OpenOffice.org source package rules file
#
# Please see debian/README for detailed documentation about the build system, and
# how to build OpenOffice.org.
################################################################################
# Authors:
# Chris Halls <halls@debian.org>
# Rene Engelhard <rene@debian.org>
# Copyright 2002-2009 Software in the Public Interest, Inc.
# Licensed under the GNU General Public License, version 2.  See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
################################################################################

PKGSOURCE := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2;exit 0}')
SOURCE_VERSION:=$(shell head -1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)
UPSTREAM_VERSION:=$(shell echo "$(SOURCE_VERSION)"| cut -d: -f2 | cut -d- -f1)
BASE_VERSION:=$(shell echo $(SOURCE_VERSION) | cut -d: -f1):$(UPSTREAM_VERSION)
BINARY_VERSION=$(SOURCE_VERSION)
#BINARY_VERSION=1:2.4.0-$(shell dpkg-parsechangelog  | grep urgency \
	| awk '{print $$2}' | sed -e s/"("// -e s/")"// | cut -d"-" -f2)
#HELP_L10N_VIRTUAL_VERSION:=$(shell echo $(UPSTREAM_VERSION) | cut -d: -f2 | tr [~] [\\-])
HELP_L10N_VIRTUAL_VERSION:=3.2
#VER:=3
OOVER:=3.2
BASIS_VERSION:=$(OOVER)

PACKAGES := $(shell dh_listpackages)
ARCH_INDEP_PACKAGES := $(shell dh_listpackages -i)
ARCH_DEP_PACKAGES := $(shell dh_listpackages -s)

OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DIST := $(shell lsb_release -is)
DISTREL := $(shell lsb_release -cs)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
SHELL:=/bin/bash

PKGDIR:=debian/openoffice.org$(VER)
OODIRNAME=openoffice$(VER)
OOBRANDDIR:=usr/lib/$(OODIRNAME)
OOBASISDIR:=$(OOBRANDDIR)/basis$(BASIS_VERSION)
OOSDKDIR:=$(OOBASISDIR)/sdk
OOUREDIR:=usr/lib/ure
# compatability
OODIR:=$(OOBASISDIR)

# Figure out who's building this package.
OOO_VENDOR:=Debian
ifeq "$(DIST)" "Ubuntu"
OOO_VENDOR+= and Ubuntu
endif
export OOO_VENDOR

# debhelper
export DH_OPTIONS
export DH_ALWAYS_EXCLUDE=CVS:.svn:.bzr:.git
#export DH_VERBOSE=1
# quilt
export QUILT_PATCHES=debian/patches
export QUILT_OPTIONS="-p1 -F0"

# work around tcsh bugs.debian.org/339034: tcsh: Unknown colorls variable `su'
unexport LS_COLORS

ifneq (,$(filter $(ARCH), arm armel))
	export ICU_ARCH_FLAGS = -Os
endif

MWS=OOO320
#MILESTONE:=$(shell echo "$(UPSTREAM_VERSION)" | cut -d~ -f2 | sed -e s/$(shell echo $(MWS) | tr A-Z a-z)//)
MILESTONE=m12
#TAG=$(shell echo $(MWS) | tr A-Z a-z)-$(MILESTONE)
TAG=$(MWS)_$(MILESTONE)
OOO_BUILD_BRANCH=ooo-build-3-2
OOO_BUILD_VERSION=3.2.0.10
OOO_BUILD_TAG=OOO_BUILD_$(shell echo $(OOO_BUILD_VERSION) | sed -e 's/\./_/g')
OOO_BUILD_TREE=ooo-build-$(shell echo $(OOO_BUILD_VERSION) | sed -e 's/\./-/g')
SOURCE_TREE=$(OOO_BUILD_TREE)/build/$(TAG)
STAMP_DIR=debian/stampdir
# unused yet but will get important for OOo 3.3
TARFILE_LOCATION=$(CURDIR)/ext-sources
export TARFILE_LOCATION

ifeq "$(DISTREL)" "lenny"
 LENNY_BACKPORT=y
endif

#########
# Default package configuration
#
BUILD_AMD64=y
BUILD_IA64=y
BUILD_PPC64=y
BUILD_S390X=y
BUILD_SPARC=y
BUILD_ARMEL=y
BUILD_HPPA=y
BUILD_ALPHA=y
PATCHSET=$(DIST)
BUILD_DEPS=
BUILD_PYUNO=y
USE_PYCENTRAL=y
USE_PYSUPPORT=n
PACKAGE_TTF_OPENSYMBOL=y
ifneq "$(ARCH)" "powerpc"
  ifneq "$(ARCH)" "ppc64"
    BUILD_JARS_NATIVE=y
 endif
endif
BUILD_BINFILTERS=y
BUILD_ONLY_EN_US=n
ENABLE_JAVA=y
JDK=openjdk
ifeq "$(ARCH)" "ia64"
  JDK=gcj-jdk
endif
ifneq (,$(findstring mips,$(ARCH)))
  JDK=gcj-jdk
endif
ifneq (,$(findstring kfreebsd,$(ARCH)))
  JDK=gcj-jdk
endif
ifeq "$(ARCH)" "hppa"
  JDK=gcj-jdk
endif
ENABLE_MONO=y
MONO2=y
ifeq "$(MONO2)" "y"
  MONO_MINVER= (>= 2.4.2.3)
else
  MONO_MINVER= (>= 1.2.3)
endif
USE_SYSTEM_HUNSPELL=y
HUNSPELL_MIN_VER= (>= 1.1.5-2)
SYSTEM_ALTLINUXHYPH=y
USE_LIBHYPHEN=y
LIBALTLINUXHYPH_MINVER= (>= 0.1.1-11)
LIBHYPHEN_MINVER= (>= 2.4)
USE_AGG=n
SYSTEM_AGG=n
USE_STLPORT=n
USE_SYSTEM_STLPORT=y
USE_SYSTEM_BOOST=y
BOOST_VERSION=default
ifeq "$(BOOST_VERSION)" "default"
  BOOST_MINVER= (>= 1.38)
endif
ifeq "$(BOOST_VERSION)" "1.39"
  BOOST_MINVER= (>= 1.39.0-2)
endif
USE_SYSTEM_VIGRA=y
USE_EXTERNAL_CXXLIBS=y
LIBWPD8_MINVER= (>= 0.8.3-3)
USE_SYSTEM_SABLOT=n
USE_LIBXSLT=y
USE_EXTERNAL_MYTHES=n
USE_SYSTEM_ICU=y
ICU_MINVER= (>= 4.0)
USE_SYSTEM_LIBWPG=y
USE_SYSTEM_LIBWPS=y
USE_SYSTEM_XMLSEC=n
BUILD_CAIROCANVAS=y
USE_SYSTEM_CAIRO=y
CAIRO_FONTS_PATCH=y
BUILD_KDE=y
KDE_VER=4
ifeq "$(BUILD_KDE)" "y"
  ifeq "$(KDE_VER)" "3"
    ENABLE_KDEAB=y
  else
    ENABLE_KDEAB=n
  endif
endif
ifeq "$(KDE_VER)" "3"
  KDELIBS_MINVER= (>= 4:3.4.3-2)
endif
ifeq "$(KDE_VER)" "4"
  QT_MINVER= (>= 4.5)
  # somehow lenny-backport picks this up although
  # KDE is 3...
  ifneq "$(LENNY_BACKPORT)" "y"
    KDELIBS_MINVER= (>= 4:4.3.4)
  endif
endif  
BUILD_DBG_PACKAGE=y
USE_SYSTEM_BSH=y
USE_SYSTEM_HSQLDB=y
HSQLDB_MINVER= (>> 1.8.0.10)
# disabled because system-saxon breaks all kinds exports using XSLT transforms
# (e.g. M$ Word/Excel 2003 XML, Mediawiki, XHTML, UOF, ...)
# It does *NOT* fail with _plain_ saxon 9.0.0.8 built with OOos build.xml
# for UOF, but still for e.g. M$.
USE_SYSTEM_SAXON=n
USE_SYSTEM_LUCENE=y
USE_SYSTEM_LPSOLVE=y
USE_SHARED_LPSOLVE=y
LPSOLVE_MIN_VERSION= (>= 5.5.0.13-5+b1)
USE_DBUS=y
USE_GSTREAMER=y
USE_SYSTEM_NEON=y
NEON_SECTYPE=gnutls
NEONSONR=27
USE_SYSTEM_REDLAND=y
USE_OOO_BUILD_DESKTOPS=n
PACKAGE_SDK=y
RUN_SMOKETEST=n
RUN_API_TESTS=n
RUN_UNIT_TESTS=n
USE_LIBCURL4=y
CURL_SECTYPE=gnutls
USE_SYSTEM_DMAKE=y
USE_LIBSUITESPARSE=y
SUITESPARSE_MIN_VERSION= (>= 1:3.4.0)
PARALLEL_BUILD=n
USE_COMMON_DOCDIR=n
MOZILLA=libxul
ENABLE_LDAP=y
USE_OPENLDAP=y
ENABLE_OPENGL=y
SYSTEM_OPENSSL=y
NEW_DPKG_SHLIBDEPS=y
ifeq "$(ENABLE_JAVA)" "y"
  # can be reenabled after cws rptfix04
  ENABLE_REPORTDESIGN=y
  USE_SYSTEM_JFREEREPORT=y
  ENABLE_MEDIAWIKI=y
  USE_SYSTEM_APACHE_COMMONS=y
else
  ENABLE_REPORTDESIGN=n
  ENABLE_MEDIAWIKI=n
endif
ENABLE_SDBC_POSTGRESQL=y
ENABLE_MINIMIZER=y
ENABLE_PRESENTER_CONSOLE=y
ENABLE_PDFIMPORT=y
BUILD_GTK=y
ENABLE_EVO2=y
ENABLE_GVFS=y
ENABLE_GCONF=y
# broken!
ENABLE_GIO=n
ENABLE_RANDR=y
ENABLE_LAYOUT=y
ifeq "$(BUILD_GTK)" "y"
  PACKAGE_NPSOPLUGIN=y
endif
# "new" source split? This is to be n when to use
# Suns tarballs.
WITH_SPLIT=n
ENABLE_GRAPHITE=y
USE_SYSTEM_GRAPHITE=y
ALLOC=system
DEBSRC_VERSION=3.0

# when we have a package we want to have to be installed on older things with some older
# C++ ABI (like it was the case with openoffice.org2), we need to set this. Don't touch
# otherwise
INTERNAL_STDLIBS=n
DEFAULT_IMAGE=galaxy
IMAGES:=$(DEFAULT_IMAGE) industrial crystal hicontrast tango oxygen classic
ENABLE_MYSQLNATIVE=y
# cannot be disabled, unless you have a internal MySQL somewhere :-)
USE_SYSTEM_MYSQLCLIENT=y
USE_SYSTEM_MYSQLCPPCONN=y
MYSQLCPPCONN_MINVER= (>= 1.1.0~r791)
DICT_DIR=/usr/share/hunspell
HYPH_DIR=/usr/share/hyphen
THES_DIR=/usr/share/mythes

# Default flags to pass to configure of ooo-build
CONFIGURE_FLAGS= --disable-post-install-scripts \
                 --with-tag=$(TAG) \
                --with-distro=$(PATCHSET) \
		--with-vendor='$(OOO_VENDOR)' \
                --enable-package-directories \
                --with-installed-ooo-dirname=$(OODIRNAME) \
                --mandir=/usr/share/man \
                --with-docdir=/usr/share/doc/openoffice.org \
                --with-build-version="ooo-build $(OOO_BUILD_VERSION), Debian $(BINARY_VERSION), `LC_ALL=C date`" \
                --disable-strip \
                --enable-lockdown \
		--with-drink=coffee \
		--libdir=/usr/lib \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--enable-hids \
		--with-system-dicts \
		--with-additional-sections="$(ADDITIONAL_SECTIONS)" \
		--without-git

ifneq "$(WITH_SPLIT)" "y"
	CONFIGURE_FLAGS += --without-split
endif
