=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg\.\d+$// http://ftp.gwdg.de/pub/openoffice/stable/(\d.\d.\d)/OOo_(\d.\d.\d)_src_core\.tar\.bz2
